## rocm-device-libs 5.0.0

=== CMakeLists.txt ===
##===--------------------------------------------------------------------------
##                   ROCm Device Libraries
##
## This file is distributed under the University of Illinois Open Source
## License. See LICENSE.TXT for details.
##===--------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.13.4)

project(ROCm-Device-Libs VERSION "1.0.0")
cmake_policy(SET CMP0011 NEW)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  include(CMakePackageConfigHelpers)
  include(GNUInstallDirs)

  find_package(ROCM)
  if (ROCM_FOUND)
    include(ROCMSetupVersion)
    rocm_setup_version(VERSION "${PROJECT_VERSION}")
  endif()
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# Optionally, build Device Libs with ccache.
set(ROCM_CCACHE_BUILD OFF CACHE BOOL "Set to ON for a ccache enabled build")
if (ROCM_CCACHE_BUILD)
  find_program(CCACHE_PROGRAM ccache)
  if (CCACHE_PROGRAM)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_PROGRAM})
  else()
    message(WARNING "Unable to find ccache. Falling back to real compiler")
  endif() # if (CCACHE_PROGRAM)
endif() # if (ROCM_CCACHE_BUILD)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  find_package(LLVM REQUIRED)
  find_package(Clang HINTS ${LLVM_DIR}/../clang)

  list(APPEND CMAKE_MODULE_PATH ${LLVM_DIR})

  if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/dist CACHE INTERNAL "Prefix prepended to install directories")
  endif()

  set(ROCM_DEVICELIB_STANDALONE_BUILD ON)
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)


if (NOT DEFINED AMDGPU_TARGET_TRIPLE)
  set(AMDGPU_TARGET_TRIPLE "amdgcn-amd-amdhsa")
endif()

if (NOT PREPARE_BUILTINS)
  add_subdirectory(utils/prepare-builtins)
  set (PREPARE_BUILTINS $<TARGET_FILE:prepare-builtins>)
endif()

include(OCL)

set(AMDGCN_LIB_LIST)
set(AMDGCN_DEP_LIST)
add_subdirectory(irif)
add_subdirectory(oclc)
add_subdirectory(ocml)
add_subdirectory(ockl)
add_subdirectory(opencl)
add_subdirectory(hip)
add_subdirectory(asanrtl)

enable_testing()
add_subdirectory(test/constant_folding)

include(Packages)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  ## CPack standard variables
  set ( CPACK_PACKAGE_NAME "rocm-device-libs" )
  set ( CPACK_PACKAGE_VERSION_MAJOR "${PROJECT_VERSION_MAJOR}" )
  set ( CPACK_PACKAGE_VERSION_MINOR "${PROJECT_VERSION_MINOR}" )
  set ( CPACK_PACKAGE_VERSION_PATCH "${PROJECT_VERSION_PATCH}" )
  set ( CPACK_PACKAGE_VERSION "${PROJECT_VERSION}" )
  set ( CPACK_PACKAGE_CONTACT "Advanced Micro Devices Inc." )
  set ( CPACK_PACKAGE_DESCRIPTION_SUMMARY "Radeon Open Compute - device libraries" )
  set ( CPACK_PACKAGE_DESCRIPTION "This package includes LLVM bitcode libraries." )
  set ( CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/RadeonOpenCompute/ROCm-Device-Libs" )

  set ( CPACK_GENERATOR "DEB;RPM" CACHE STRING "Default packaging generators." )

  ## ROCM version updates as per naming convention
  set ( ROCM_VERSION_FOR_PACKAGE "99999" )
  if( DEFINED ENV{ROCM_LIBPATCH_VERSION} )
    set ( ROCM_VERSION_FOR_PACKAGE $ENV{ROCM_LIBPATCH_VERSION} )
  endif()
  ## Debian package values
  set ( CPACK_DEBIAN_PACKAGE_MAINTAINER "ROCm Compiler Support <rocm.compiler.support@amd.com>" )

  set ( CPACK_DEBIAN_PACKAGE_RELEASE "local" )
  if( DEFINED ENV{CPACK_DEBIAN_PACKAGE_RELEASE} )
    set ( CPACK_DEBIAN_PACKAGE_RELEASE $ENV{CPACK_DEBIAN_PACKAGE_RELEASE} )
  endif()
  ## RPM package variables
  set ( CPACK_RPM_PACKAGE_RELEASE "local" )
  if( DEFINED ENV{CPACK_RPM_PACKAGE_RELEASE} )
    set ( CPACK_RPM_PACKAGE_RELEASE $ENV{CPACK_RPM_PACKAGE_RELEASE} )
  endif()
  ## get distro for RPM package using dist
  message("device-libs CPACK_RPM_PACKAGE_RELEASE now is ${CPACK_RPM_PACKAGE_RELEASE}")

  execute_process( COMMAND rpm --eval %{?dist}
                 RESULT_VARIABLE _result_var
                 OUTPUT_VARIABLE _output_var
                 OUTPUT_STRIP_TRAILING_WHITESPACE )
  if( _result_var EQUAL "0" AND NOT _output_var STREQUAL "" )
    string (APPEND CPACK_RPM_PACKAGE_RELEASE ${_output_var})
  endif()
  # set package name as per standard
  set ( CPACK_PACKAGE_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.${ROCM_VERSION_FOR_PACKAGE}" )

  set ( CPACK_RPM_FILE_NAME "RPM-DEFAULT" )
  set ( CPACK_RPM_PACKAGE_REQUIRES "rocm-core" )
  set ( CPACK_DEBIAN_FILE_NAME "DEB-DEFAULT" )
  set ( CPACK_DEBIAN_PACKAGE_DEPENDS "rocm-core" )
  # Remove dependency on rocm-core if -DROCM_DEP_ROCMCORE=ON not given to cmake
  if(NOT ROCM_DEP_ROCMCORE)
      string(REGEX REPLACE ",? ?rocm-core" "" CPACK_RPM_PACKAGE_REQUIRES ${CPACK_RPM_PACKAGE_REQUIRES})
      string(REGEX REPLACE ",? ?rocm-core" "" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
  endif()
  include( CPack )
endif()

=== ocml/CMakeLists.txt ===
##===--------------------------------------------------------------------------
##                   ROCm Device Libraries
##
## This file is distributed under the University of Illinois Open Source
## License. See LICENSE.TXT for details.
##===--------------------------------------------------------------------------

file(GLOB sources
  ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cl
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../irif/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../oclc/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)

opencl_bc_lib(NAME ocml SOURCES ${sources})

=== opencl/CMakeLists.txt ===
##===--------------------------------------------------------------------------
##                   ROCm Device Libraries
##
## This file is distributed under the University of Illinois Open Source
## License. See LICENSE.TXT for details.
##===--------------------------------------------------------------------------

file(GLOB cl_sources
  ${CMAKE_CURRENT_SOURCE_DIR}/src/async/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/common/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/devenq/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/geometric/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/image/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/integer/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/math/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/media/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/misc/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/pipes/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/relational/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/subgroup/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/vldst/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/workgroup/*.cl
  )

file(GLOB sources ${cl_sources})

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/integer)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src/workgroup)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../irif/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../ocml/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../ockl/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../oclc/inc)

opencl_bc_lib(NAME opencl SOURCES ${sources})

=== utils/prepare-builtins/CMakeLists.txt ===
##===--------------------------------------------------------------------------
##                   ROCm Device Libraries
##
## This file is distributed under the University of Illinois Open Source
## License. See LICENSE.TXT for details.
##===--------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.13.4)

include(AddLLVM)

if (ROCM_DEVICELIB_STANDALONE_BUILD)
  add_definitions(${LLVM_DEFINITIONS})
  include_directories(${LLVM_INCLUDE_DIR})
  include_directories(${LLVM_CONFIG_INCLUDE_DIR})
  include_directories(${LLVM_MAIN_INCLUDE_DIR})

  include_directories(${LLVM_INCLUDE_DIRS})
  add_definitions(${LLVM_DEFINITIONS})
  link_directories("${LLVM_LIBRARY_DIR}")
endif()

add_executable(prepare-builtins prepare-builtins.cpp)
set_target_properties(prepare-builtins PROPERTIES
  CXX_STANDARD 14
  CXX_STANDARD_REQUIRED Yes
  CXX_EXTENSIONS No)
llvm_update_compile_flags(prepare-builtins)
llvm_map_components_to_libnames(llvm_libs support core bitreader bitwriter)
target_link_libraries(prepare-builtins ${llvm_libs})

=== debian/changelog ===
rocm-device-libs (5.0.0-1) unstable; urgency=medium

  [ Maxime Chambonnet ]
  * New upstream version 5.0.0
  * d/rules: -$(RM) obj-* (temporary build directory).
  * Update LLVM BD to version 14

  [ Étienne Mollier ]
  * cmake-amdgcn-bitcode.patch: forwarded upstream
  * d/rules: make clean step triplet independent
  * d/control: rocm-device-libs Architecture: any
  * cmake-amdgcn-bitcode.patch: target TRIPLET

  [ Mo Zhou ]
  * Add versioned requirement (>= 5.0.0~) on B-D rocm-cmake.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Mon, 14 Feb 2022 16:05:54 -0500

rocm-device-libs (4.5.2-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #1004309)

 -- Étienne Mollier <emollier@debian.org>  Thu, 03 Feb 2022 22:23:34 +0100

=== debian/control ===
Source: rocm-device-libs
Section: devel
Homepage: https://github.com/RadeonOpenCompute/ROCm-Device-Libs/
Priority: optional
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/rocm-team/rocm-device-libs.git
Vcs-Browser: https://salsa.debian.org/rocm-team/rocm-device-libs
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>,
           Norbert Preining <norbert@preining.info>,
           Étienne Mollier <emollier@debian.org>,
           Maxime Chambonnet <maxzor@maxzor.eu>
Build-Depends: cmake,
               debhelper-compat (= 13),
               clang-14,
               libclang-14-dev,
               llvm-14-dev,
               rocm-cmake (>= 5.0.0~),
               zlib1g-dev
Rules-Requires-Root: no

Package: rocm-device-libs
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: AMD specific device-side language runtime libraries
 Set of AMD specific device-side language runtime libraries, specifically: the
 Open Compute library controls, the Open Compute Math library, the Open Compute
 Kernel library, the OpenCL built-in library, the HIP built-in library, and the
 Heterogeneous Compute built-in library.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=-all

%:
	dh $@ -Scmake

execute_before_dh_clean:
	-$(RM) -rf obj-*/

## rocm-device-libs 5.1.0

=== debian/changelog ===
rocm-device-libs (5.1.0-1) unstable; urgency=medium

  * New upstream version 5.1.0
  * Require rocm-cmake (>= 5.1.0~) as B-D.

 -- Mo Zhou <lumin@debian.org>  Thu, 07 Apr 2022 12:21:26 -0400

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
                clang-14,
                libclang-14-dev,
                llvm-14-dev,
-               rocm-cmake (>= 5.0.0~),
+               rocm-cmake (>= 5.1.0~),
                zlib1g-dev
 Rules-Requires-Root: no

## rocm-device-libs 5.2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -84,7 +84,12 @@
   set ( CPACK_PACKAGE_CONTACT "Advanced Micro Devices Inc." )
   set ( CPACK_PACKAGE_DESCRIPTION_SUMMARY "Radeon Open Compute - device libraries" )
   set ( CPACK_PACKAGE_DESCRIPTION "This package includes LLVM bitcode libraries." )
+  set ( CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.TXT" )
   set ( CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/RadeonOpenCompute/ROCm-Device-Libs" )
+
+  # Install License file
+  install ( FILES "${CPACK_RESOURCE_FILE_LICENSE}"
+          DESTINATION ${CMAKE_INSTALL_DOCDIR}/${CPACK_PACKAGE_NAME})
 
   set ( CPACK_GENERATOR "DEB;RPM" CACHE STRING "Default packaging generators." )
 
@@ -107,6 +112,7 @@
   endif()
   ## get distro for RPM package using dist
   message("device-libs CPACK_RPM_PACKAGE_RELEASE now is ${CPACK_RPM_PACKAGE_RELEASE}")
+  set( CPACK_RPM_PACKAGE_LICENSE "NCSA" )
 
   execute_process( COMMAND rpm --eval %{?dist}
                  RESULT_VARIABLE _result_var

=== ockl/CMakeLists.txt ===
##===--------------------------------------------------------------------------
##                   ROCm Device Libraries
##
## This file is distributed under the University of Illinois Open Source
## License. See LICENSE.TXT for details.
##===--------------------------------------------------------------------------

file(GLOB sources
  ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cl
  ${CMAKE_CURRENT_SOURCE_DIR}/src/*.ll
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../irif/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../oclc/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/inc)

opencl_bc_lib(NAME ockl SOURCES ${sources})

=== test/constant_folding/CMakeLists.txt ===
##===--------------------------------------------------------------------------
##                   ROCm Device Libraries
##
## This file is distributed under the University of Illinois Open Source
## License. See LICENSE.TXT for details.
##===--------------------------------------------------------------------------

if(TARGET FileCheck)
  set(FILECHECK_BIN $<TARGET_FILE:FileCheck>)
else()
  # FIXME: Is there a better way to get the binary directory?
  # FileCheck is also not normally installed, so it only really works
  # well with build directories by default.
  find_program(FILECHECK_BIN FileCheck
    HINTS ${LLVM_DIR}/../../../bin)
endif()

if(NOT FILECHECK_BIN)
  message(STATUS "FileCheck not found, not adding constant fold tests")
  return()
endif()

message(STATUS "Running constant fold tests")

function(add_constant_fold_test name)
  add_test(NAME constant_fold_${name}
    COMMAND ${CMAKE_COMMAND}
     -DCLANG_BIN=$<TARGET_FILE:clang>
     -DBINARY_DIR=${PROJECT_BINARY_DIR}
     -DFILECHECK_BIN=${FILECHECK_BIN}
     -DOUTPUT_FILE=output.${name}.ll
     -DINPUT_FILE=${CMAKE_CURRENT_SOURCE_DIR}/${name}.cl
     -DTEST_CPU=gfx900
     -P ${CMAKE_CURRENT_SOURCE_DIR}/RunConstantFoldTest.cmake)
endfunction()

add_constant_fold_test(lgamma_r)

=== debian/changelog ===
rocm-device-libs (5.2.3-2) unstable; urgency=medium

  * d/rules: link atomic for platforms which need it.
  * d/salsa-ci.yml: disable blhc test; no hardening.

 -- Étienne Mollier <emollier@debian.org>  Sun, 20 Nov 2022 19:41:59 +0100

rocm-device-libs (5.2.3-1) unstable; urgency=medium

  * Migrate ROCm 5.2.3 to unstable.
  * d/control: build depends on ROCm 5.2 packages.
  * d/control: bump build dependency to llvm 15.
  * d/control: update build-dependencies to new llvm packages layout.

 -- Étienne Mollier <emollier@debian.org>  Tue, 18 Oct 2022 18:03:30 +0200

rocm-device-libs (5.2.3-1~0exp0) experimental; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * d/rules: remove directory tree containing only an extra license file.

 -- Étienne Mollier <emollier@debian.org>  Tue, 06 Sep 2022 20:33:33 +0200

=== debian/control ===
Source: rocm-device-libs
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>,
           Norbert Preining <norbert@preining.info>,
           Étienne Mollier <emollier@debian.org>,
           Maxime Chambonnet <maxzor@maxzor.eu>
Section: devel
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               clangd-15,
               clang-15,
               clang-format-15,
               clang-tidy-15,
               clang-tools-15,
               libclang-15-dev,
               libmlir-15-dev,
               llvm-15-dev,
               mlir-15-tools,
               rocm-cmake (>= 5.2.0~),
               zlib1g-dev
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/rocm-team/rocm-device-libs
Vcs-Git: https://salsa.debian.org/rocm-team/rocm-device-libs.git
Homepage: https://github.com/RadeonOpenCompute/ROCm-Device-Libs/
Rules-Requires-Root: no

Package: rocm-device-libs
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: AMD specific device-side language runtime libraries
 Set of AMD specific device-side language runtime libraries, specifically: the
 Open Compute library controls, the Open Compute Math library, the Open Compute
 Kernel library, the OpenCL built-in library, the HIP built-in library, and the
 Heterogeneous Compute built-in library.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=-all

ifneq ($(filter $(DEB_HOST_ARCH),armel mipsel powerpc),)
CMAKEFLAGS += -DCMAKE_CXX_STANDARD_LIBRARIES=-latomic
endif

%:
	dh $@ -Scmake

execute_before_dh_clean:
	-$(RM) -rf obj-*/

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKEFLAGS)

execute_before_dh_install:
	# The directory below only contains a license file deep in the tree.
	rm -rvf $(CURDIR)/debian/rocm-device-libs/usr/share/doc/ROCm-Device-Libs

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?rocm-(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
	https://github.com/RadeonOpenCompute/ROCm-Device-Libs/tags \
	(?:.*?/)?rocm-@ANY_VERSION@@ARCHIVE_EXT@

## rocm-device-libs 6.0+git20231212.5a852ed

=== CMakeLists.txt ===
--- 
+++ 
@@ -61,7 +61,6 @@
 
 set(AMDGCN_LIB_LIST)
 set(AMDGCN_DEP_LIST)
-add_subdirectory(irif)
 add_subdirectory(oclc)
 add_subdirectory(ocml)
 add_subdirectory(ockl)
@@ -70,7 +69,7 @@
 add_subdirectory(asanrtl)
 
 enable_testing()
-add_subdirectory(test/constant_folding)
+add_subdirectory(test/compile)
 
 include(Packages)
 
@@ -89,7 +88,7 @@
 
   # Install License file
   install ( FILES "${CPACK_RESOURCE_FILE_LICENSE}"
-          DESTINATION ${CMAKE_INSTALL_DOCDIR}/${CPACK_PACKAGE_NAME})
+          DESTINATION ${CMAKE_INSTALL_DOCDIR})
 
   set ( CPACK_GENERATOR "DEB;RPM" CACHE STRING "Default packaging generators." )

=== asanrtl/CMakeLists.txt ===
##===--------------------------------------------------------------------------
##                   ROCm Device Libraries
##
## This file is distributed under the University of Illinois Open Source
## License. See LICENSE.TXT for details.
##===--------------------------------------------------------------------------

file(GLOB sources
  ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cl
)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../irif/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../oclc/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../ockl/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/inc)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)

opencl_bc_lib(NAME asanrtl SOURCES ${sources})

=== ocml/CMakeLists.txt ===
--- 
+++ 
@@ -7,11 +7,29 @@
 
 file(GLOB sources
   ${CMAKE_CURRENT_SOURCE_DIR}/src/*.cl
-)
+  )
 
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../irif/inc)
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../oclc/inc)
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/inc)
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)
 
+set(native_func_flags -fapprox-func)
+
+# Minimal flags required to enable v_rcp_f16
+#
+# TODO: Approx func is stronger than required. Need !fpmath 1.0 set on
+# the fdiv, but there's no direct control for this now.
+set(rcp_f16_flags -freciprocal-math ${native_func_flags})
+
+set_source_files_properties(
+  ${CMAKE_CURRENT_SOURCE_DIR}/src/native_rcpH.cl
+  ${CMAKE_CURRENT_SOURCE_DIR}/src/native_rsqrtH.cl
+  PROPERTIES COMPILE_FLAGS "${rcp_f16_flags}")
+
+set_source_files_properties(
+  ${CMAKE_CURRENT_SOURCE_DIR}/src/native_logF.cl
+  ${CMAKE_CURRENT_SOURCE_DIR}/src/native_expF.cl
+  PROPERTIES COMPILE_FLAGS "${native_func_flags}")
+
 opencl_bc_lib(NAME ocml SOURCES ${sources})

=== test/compile/CMakeLists.txt ===
##===--------------------------------------------------------------------------
##                   ROCm Device Libraries
##
## This file is distributed under the University of Illinois Open Source
## License. See LICENSE.TXT for details.
##===--------------------------------------------------------------------------

if(TARGET FileCheck)
  set(FILECHECK_BIN $<TARGET_FILE:FileCheck>)
else()
  # FIXME: Is there a better way to get the binary directory?
  # FileCheck is also not normally installed, so it only really works
  # well with build directories by default.
  find_program(FILECHECK_BIN FileCheck
    HINTS ${LLVM_DIR}/../../../bin)
endif()

if(NOT FILECHECK_BIN)
  message(STATUS "FileCheck not found, not adding constant fold tests")
  return()
endif()

message(STATUS "Running constant fold tests")

function(add_compile_test test_name func_name script test_cpu extra_check_prefixes)
  add_test(NAME ${test_name}__${test_cpu}
    COMMAND ${CMAKE_COMMAND}
     -DCLANG_BIN=$<TARGET_FILE:clang>
     -DBINARY_DIR=${PROJECT_BINARY_DIR}
     -DFILECHECK_BIN=${FILECHECK_BIN}
     -DOUTPUT_FILE=output.${name}.${test_cpu}.s
     -DINPUT_FILE=${CMAKE_CURRENT_SOURCE_DIR}/${func_name}.cl
     -DTEST_CPU=${test_cpu}
     -DEXTRA_CHECK_PREFIX=${extra_check_prefixes}
     -P ${script})
endfunction()


# Add constant folding tests
function(add_constant_fold_test name test_cpu)
  add_compile_test(constant_fold_${name} ${name}
                  ${CMAKE_CURRENT_SOURCE_DIR}/RunConstantFoldTest.cmake ${test_cpu} CHECK)
endfunction()

# Add full to ISA compile tests
function(add_isa_test name test_cpu)
  string(TOUPPER ${test_cpu} check_prefix)
  add_compile_test(compile_${name} ${name}
                   ${CMAKE_CURRENT_SOURCE_DIR}/RunCompileTest.cmake ${test_cpu} "${check_prefix},GCN")
endfunction()

foreach(gpu gfx803)
  add_isa_test(asin ${gpu})
  add_isa_test(atan2 ${gpu})
  add_isa_test(atan2pi ${gpu})
endforeach()

foreach(gpu gfx600 gfx700 gfx803)
  add_isa_test(native_rcp ${gpu})
  add_isa_test(native_rsqrt ${gpu})
  add_isa_test(native_log ${gpu})
  add_isa_test(native_exp ${gpu})
endforeach()

=== debian/changelog ===
rocm-device-libs (6.0+git20231212.5a852ed-2) unstable; urgency=medium

  * d/rules: strip unsupported -fno-cf-protection flag
  * d/control: trim build-depends

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 23 Feb 2024 22:30:22 -0700

rocm-device-libs (6.0+git20231212.5a852ed-1) unstable; urgency=medium

  * Migrate to unstable. (Closes #1055950)

 -- Cordell Bloor <cgmb@slerp.xyz>  Wed, 21 Feb 2024 23:59:44 -0700

rocm-device-libs (6.0+git20231212.5a852ed-1~exp1) experimental; urgency=medium

  * New upstream version 6.0+git20231212.5a852ed
  * Remove rocm-device-libs binary package for LLVM 15
  * Add rocm-device-libs-17 binary package for LLVM 17
  * Move bitcode files to clang resource directory
  * Update upstream URLs
  * Add self to uploaders

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 05 Jan 2024 01:39:54 -0700

rocm-device-libs (5.2.3-3) unstable; urgency=medium

  * Add libzstd-dev to Build-Depends. (Closes: #1045688)
  * Add myself to Uploaders
  * Bump Standards-Version to 4.6.2 (no changes needed)

 -- Christian Kastner <ckk@debian.org>  Tue, 15 Aug 2023 22:37:41 +0200

=== debian/control ===
Source: rocm-device-libs
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>,
           Norbert Preining <norbert@preining.info>,
           Étienne Mollier <emollier@debian.org>,
           Maxime Chambonnet <maxzor@maxzor.eu>,
           Christian Kastner <ckk@debian.org>,
           Cordell Bloor <cgmb@slerp.xyz>,
Section: devel
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               clang-17,
               clang-tools-17,
               libclang-17-dev,
               libzstd-dev,
               llvm-17-dev,
               rocm-cmake (>= 5.2.0~),
               zlib1g-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/rocm-team/rocm-device-libs
Vcs-Git: https://salsa.debian.org/rocm-team/rocm-device-libs.git
Homepage: https://github.com/ROCm/ROCm-Device-Libs/
Rules-Requires-Root: no

Package: rocm-device-libs-17
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: AMD specific device-side language runtime libraries
 Set of AMD specific device-side language runtime libraries, specifically: the
 Open Compute library controls, the Open Compute Math library, the Open Compute
 Kernel library, the OpenCL built-in library, the HIP built-in library, and the
 Heterogeneous Compute built-in library.

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,10 @@
 ifneq ($(filter $(DEB_HOST_ARCH),armel mipsel powerpc),)
 CMAKEFLAGS += -DCMAKE_CXX_STANDARD_LIBRARIES=-latomic
 endif
+
+# strip unsupported flags
+CFLAGS := $(subst -fno-cf-protection,,$(CXXFLAGS))
+CXXFLAGS := $(subst -fno-cf-protection,,$(CXXFLAGS))
 
 %:
 	dh $@ -Scmake
@@ -16,4 +20,4 @@
 
 execute_before_dh_install:
 	# The directory below only contains a license file deep in the tree.
-	rm -rvf $(CURDIR)/debian/rocm-device-libs/usr/share/doc/ROCm-Device-Libs
+	rm -rvf $(CURDIR)/debian/rocm-device-libs-17/usr/share/doc/ROCm-Device-Libs

=== debian/watch ===
version=4
opts="mode=git, pretty=6.0+git%cd.%h, pgpmode=none" \
	https://github.com/ROCm/ROCm-Device-Libs \
	heads/release/17.x debian uupdate
